'use client'
import { MoreVertical } from "react-feather";
import useReSendStore from "@/feature/messenger/store/useReSendStore";
import { Dropdown, DropdownItem, DropdownMenu, DropdownSection, DropdownTrigger, Tooltip } from "@nextui-org/react";
import { useTranslation } from "@/hooks/useTranslation";
import useMessageInformation from "@/feature/messenger/store/useMessageInformation";
import useConfigChatStore from "@/feature/messenger/store/chat_store/useConfigChatStore";
import useRigthSidebarStore from "@/feature/messenger/store/useRigthSidebarStore";
import toast from "react-hot-toast";

const ReSendMessage = ({ message }: any) => {

    const hadleCloseModalReSend = useReSendStore(state => state.handleOpenModalReSend);
    const colorIcon = message?.quien_ejecuta_proceso === "usuario" ? "text-gray-400 hover:text-gray-600" : "text-white hover:text-gray-400";
    const position = message?.quien_ejecuta_proceso === "usuario" ? "top-3 right-0" : "top-3 left-0";
    const { trans } = useTranslation();
    const { getDetailMessage } = useMessageInformation();
    const {handleChangeTypeContent, handleOpenRigthSidebar} = useRigthSidebarStore();
    const handleOpenModalMessageInformation = async (id_chatbot: string, id_log: string,message: string) => {
        const response = await getDetailMessage(id_chatbot, id_log,message);
        if(response === false){
            toast.success(trans("sidebar_message_information_no_information_title"));
        }else{
            handleChangeTypeContent('message-information');
            handleOpenRigthSidebar();
        }
    }
    const isEmail = (text: string) => {
        const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return emailRegex.test(text);
    };
    return (
        <>
            <div className={`absolute ${position} ${colorIcon} ${message?.rsocial === "whatsapp" && isEmail(message.quien_ejecuta_proceso) ? "" : "hidden"}`}>
                <Dropdown placement="top">
                    <Tooltip
                        placement="bottom"
                        content={trans('header_options_dropdown_content_chat_title')}	
                        color="default"
                    >
                        <div>
                            <DropdownTrigger>
                                <MoreVertical className={colorIcon} size={22} />
                            </DropdownTrigger>
                        </div>
                    </Tooltip>
                    <DropdownMenu aria-label="Profile Actions" variant="faded" className="p-2">
                        <DropdownSection title="Opciones">
                            {/*<DropdownItem key="reenviar" className="text-lg d-none" onClick={() => hadleCloseModalReSend(message, message.sesion)} textValue="reenviar">
                                <p className="text-base">{trans('content_chat_dropdown_resend_message_title')}</p>
                            </DropdownItem>*/}
                            <DropdownItem key="info_mensaje" className="text-lg" onClick={() => handleOpenModalMessageInformation(message.id_chatbot, message.id_log, message.conversacion)} textValue="info_mensaje">
                                <p className="text-base">{trans('content_chat_dropdown_info_message_title')}</p>
                            </DropdownItem>
                        </DropdownSection>
                    </DropdownMenu>
                </Dropdown>
            </div>
        </>

    )
}

export default ReSendMessage